Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.scoringFunctions.mix.motifSearch
Class HiddenMotifsMixture

    java.lang.Object
      de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
          de.jstacs.scoringFunctions.mix.AbstractMixtureScoringFunction
              de.jstacs.scoringFunctions.mix.motifSearch.HiddenMotifsMixture

All Implemented Interfaces:
  MotifDiscoverer, MutableMotifDiscoverer, NormalizableScoringFunction, ScoringFunction, Storable, Cloneable

    public class HiddenMotifsMixture

extends AbstractMixtureScoringFunction
implements MutableMotifDiscoverer

This class handles mixtures with at least one hidden motif.

Author:
  Jens Keilwagen

Nested Class Summary

Nested classes/interfaces inherited from interface de.jstacs.motifDiscovery.MotifDiscoverer
`MotifDiscoverer.KindOfProfile`

Field Summary
`static boolean` | `CONTAINS_ALWAYS_A_MOTIF` This constant indicates that in each sequence has one binding site of a motif instance (similar to OOPS).
`static boolean` | `CONTAINS_SOMETIMES_A_MOTIF` This constant indicates that a sequence possibly has one binding site of a motif instance (similar to ZOOPS).
`static double` | `DEFAULT_SIGN` The default significance level that is used in `Mutable.determineNotSignificantPositions(double, double[], double[], double[][][][], double[][][][], double)`.

Fields inherited from class de.jstacs.scoringFunctions.mix.AbstractMixtureScoringFunction
`componentScore, dList, freeParams, function, hiddenParameter, hiddenPotential, iList, isNormalized, logGammaSum, logHiddenNorm, logHiddenPotential, norm, optimizeHidden, paramRef, partNorm`

Fields inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`alphabets, length, r`

Fields inherited from interface de.jstacs.scoringFunctions.ScoringFunction
`UNKNOWN`

Constructor Summary
`HiddenMotifsMixture(boolean type, int length, int starts, boolean plugIn, HomogeneousScoringFunction bg, NormalizableScoringFunction[] motif, DurationScoringFunction[] posPrior, boolean plugInBg)` This constructor creates an instance of `HiddenMotifsMixture` that allows to have one site of the specified motifs in a `Sequence`.
`HiddenMotifsMixture(boolean type, int length, int starts, boolean plugIn, HomogeneousScoringFunction bg, NormalizableScoringFunction[] motif, DurationScoringFunction[] posPrior, double sign, boolean plugInBg)` This constructor creates an instance of `HiddenMotifsMixture` that allows to have one site of the specified motifs in a `Sequence`.
`HiddenMotifsMixture(boolean type, int length, int starts, boolean plugIn, HomogeneousScoringFunction bg, NormalizableScoringFunction motif, DurationScoringFunction posPrior, boolean plugInBg)` This constructor creates an instance of `HiddenMotifsMixture` that is either an OOPS or a ZOOPS model depending on the chosen `type`.
`HiddenMotifsMixture(boolean type, int length, int starts, boolean plugIn, HomogeneousScoringFunction bg, NormalizableScoringFunction motif, DurationScoringFunction posPrior, double sign, boolean plugInBg)` This constructor creates an instance of `HiddenMotifsMixture` that is either an OOPS or a ZOOPS model depending on the chosen `type`.
`HiddenMotifsMixture(StringBuffer source)` This is the constructor for the interface `Storable`.

Method Summary
`void` | `adjustHiddenParameters(Sample data, double[] dataWeights)` This method allows to adjust the hidden parameter in some way.
`HiddenMotifsMixture` | `clone()` Creates a clone (deep copy) of the current `ScoringFunction` instance.
`int[]` | `determineNotSignificantPositionsFor(int motif, Sample[] data, double[][] weights, int classIdx)` This method determines the number of not significant positions from each side of the motif with index `motif`.
`protected void` | `extractFurtherInformation(StringBuffer xml)` This method is the opposite of `AbstractMixtureScoringFunction.getFurtherInformation()`.
`protected int` | `fillComponentScoreOf(int i, Sequence seq, int start)` This method fills an internal array with the partial scores.
`protected void` | `fillComponentScores(Sequence seq, int start)` Fills the internal array `AbstractMixtureScoringFunction.componentScore` with the logarithmic scores of the components given a `Sequence`.
`double` | `getEss()` Returns the equivalent sample size (ess) of this model, i.e. the equivalent sample size for the class or component that is represented by this model.
`protected StringBuffer` | `getFurtherInformation()` This method is used to append further information of the instance to the XML representation.
`int` | `getGlobalIndexOfMotifInComponent(int component, int motif)` Returns the global index of the `motif` used in `component`.
`double` | `getHyperparameterForHiddenParameter(int index)` This method returns the hyperparameter for the hidden parameter with index `index`.
`int` | `getIndexOfMaximalComponentFor(Sequence sequence)` Returns the index of the component with the maximal score for the sequence `sequence`.
`String` | `getInstanceName()` Returns a short instance name.
`double` | `getLogScore(Sequence seq, int start)` Returns the logarithmic score for the `Sequence` `seq` beginning at position `start` in the `Sequence`.
`double` | `getLogScoreAndPartialDerivation(Sequence seq, int start, IntList indices, DoubleList partialDer)` Returns the logarithmic score for a `Sequence` beginning at position `start` in the `Sequence` and fills lists with the indices and the partial derivations.
`int` | `getMotifLength(int motif)` This method returns the length of the motif with index `motif` .
`protected double` | `getNormalizationConstantForComponent(int i)` Computes the normalization constant for the component `i`.
`int` | `getNumberOfMotifs()` Returns the number of motifs for this `MotifDiscoverer`.
`int` | `getNumberOfMotifsInComponent(int component)` Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.
`double` | `getPartialNormalizationConstant(int parameterIndex)` Returns the partial normalization constant for the parameter with index `parameterIndex`.
`double[]` | `getProfileOfScoresFor(int component, int motif, Sequence sequence, int startpos, MotifDiscoverer.KindOfProfile dist)` Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`.
`double` | `getSign()` This method returns the sign that is used in shift, shrink and expand.
`StrandedLocatedSequenceAnnotationWithLength.Strand` | `getStrandFor(int component, int motif, Sequence sequence, int startpos)` This method returns the strand for a given subsequence if it is considered as site of the motif model in a specific component.
`void` | `initializeFunctionRandomly(boolean freeParams)` This method initializes the `ScoringFunction` randomly.
`void` | `initializeMotif(int motif, Sample data, double[] weights)` This method allows to initialize the model of a motif manually using a weighted sample.
`void` | `initializeMotifRandomly(int motif)` This method initializes the motif with index `motif` randomly using `ScoringFunction.initializeFunctionRandomly(boolean)`.
`protected void` | `initializeUsingPlugIn(int index, boolean freeParams, Sample[] data, double[][] weights)` This method initializes the functions using the data in some way.
`boolean` | `modifyMotif(int motif, double[] weightsLeft, double[] weightsRight, double[][][][] replacementLeft, double[][][][] replacementRight, int offsetLeft, int offsetRight)` Manually modifies the motif model with index `motifIndex`.
`boolean` | `modifyMotif(int motifIndex, int offsetLeft, int offsetRight)` Manually modifies the motif model with index `motifIndex`.
`void` | `setSign(double newSign)` This method set the sign that is used in shift, shrink and expand.
`String` | `toString()`

Methods inherited from class de.jstacs.scoringFunctions.mix.AbstractMixtureScoringFunction
`addGradientOfLogPriorTerm, cloneFunctions, computeHiddenParameter, computeLogGammaSum, fromXML, getCurrentParameterValues, getFunction, getFunctions, getIndexOfMaximalComponentFor, getIndices, getLogPriorTerm, getMaxIndex, getNormalizationConstant, getNumberOfComponents, getNumberOfParameters, getNumberOfRecommendedStarts, getProbsForComponent, getScoringFunctions, getSizeOfEventSpaceForRandomVariablesOfParameter, getXMLTag, init, initializeFunction, initializeHiddenPotentialRandomly, initializeHiddenUniformly, initWithLength, isInitialized, isNormalized, precomputeNorm, setHiddenParameters, setParameters, setParametersForFunction, toXML`

Methods inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`getAlphabetContainer, getInitialClassParam, getLength, getLogScore, getLogScoreAndPartialDerivation, isNormalized`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface de.jstacs.motifDiscovery.MotifDiscoverer
`getNumberOfComponents`

Methods inherited from interface de.jstacs.Storable
`toXML`

Field Detail

### CONTAINS_ALWAYS_A_MOTIF

    public static final boolean CONTAINS_ALWAYS_A_MOTIF

  This constant indicates that in each sequence has one binding site of a motif instance (similar to OOPS).

  See Also:
    Constant Field Values

### CONTAINS_SOMETIMES_A_MOTIF

    public static final boolean CONTAINS_SOMETIMES_A_MOTIF

  This constant indicates that a sequence possibly has one binding site of a motif instance (similar to ZOOPS).

  See Also:
    Constant Field Values

### DEFAULT_SIGN

    public static final double DEFAULT_SIGN

  The default significance level that is used in `Mutable.determineNotSignificantPositions(double, double[], double[], double[][][][], double[][][][], double)`.

  See Also:
    Constant Field Values

Constructor Detail

### HiddenMotifsMixture

    public HiddenMotifsMixture(boolean type,
                               int length,
                               int starts,
                               boolean plugIn,
                               HomogeneousScoringFunction bg,
                               NormalizableScoringFunction motif,
                               DurationScoringFunction posPrior,
                               boolean plugInBg)
                        throws Exception

  This constructor creates an instance of `HiddenMotifsMixture` that is either an OOPS or a ZOOPS model depending on the chosen `type`. This constructor uses the `DEFAULT_SIGN` as significance level.

  Parameters:
    `type` - the type of hidden motifs, either `CONTAINS_ALWAYS_A_MOTIF` or `CONTAINS_SOMETIMES_A_MOTIF`
    `length` - the length of the modeled sequences (e.g. 500)
    `starts` - the number of recommended starts
    `plugIn` - a switch whether to use plug-in or randomly chosen parameter when using `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`
    `bg` - the `ScoringFunction` for the overall background (i.e. flanking sequence that does not contain a motif)
    `motif` - the `ScoringFunction` for the motif
    `posPrior` - the `ScoringFunction` for the position
    `plugInBg` - a switch whether to plug in the (old = last) parameters of the background model, if `false` the background model is initialized again
  Throws:
    `Exception` - if something went wrong (e.g. the `AlphabetContainer` is not simple, ...)

### HiddenMotifsMixture

    public HiddenMotifsMixture(boolean type,
                               int length,
                               int starts,
                               boolean plugIn,
                               HomogeneousScoringFunction bg,
                               NormalizableScoringFunction motif,
                               DurationScoringFunction posPrior,
                               double sign,
                               boolean plugInBg)
                        throws Exception

  This constructor creates an instance of `HiddenMotifsMixture` that is either an OOPS or a ZOOPS model depending on the chosen `type`.

  Parameters:
    `type` - the type of hidden motifs, either `CONTAINS_ALWAYS_A_MOTIF` or `CONTAINS_SOMETIMES_A_MOTIF`
    `length` - the length of the modeled sequences (e.g. 500)
    `starts` - the number of recommended starts
    `plugIn` - a switch whether to use plug-in or randomly chosen parameter when using `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`
    `bg` - the `ScoringFunction` for the overall background (i.e. flanking sequence that does not contain a motif)
    `motif` - the `ScoringFunction` for the motif
    `posPrior` - the `ScoringFunction` for the position
    `sign` - the significance level to determine the insignificant border positions of a motif
    `plugInBg` - a switch whether to plug in the (old = last) parameters of the background model, if `false` the background model is initialized again
  Throws:
    `Exception` - if something went wrong (e.g. the `AlphabetContainer` is not simple, ...)

### HiddenMotifsMixture

    public HiddenMotifsMixture(boolean type,
                               int length,
                               int starts,
                               boolean plugIn,
                               HomogeneousScoringFunction bg,
                               NormalizableScoringFunction[] motif,
                               DurationScoringFunction[] posPrior,
                               boolean plugInBg)
                        throws Exception

  This constructor creates an instance of `HiddenMotifsMixture` that allows to have one site of the specified motifs in a `Sequence`. A pair of entries of `motif` and `pos` model a specific motif. This constructor uses the `DEFAULT_SIGN` as significance level.

  Parameters:
    `type` - the type of hidden motifs, either `CONTAINS_ALWAYS_A_MOTIF` or `CONTAINS_SOMETIMES_A_MOTIF`
    `length` - the length of the modeled sequences (e.g. 500)
    `starts` - the number of recommended starts
    `plugIn` - a switch whether to use plug-in or randomly chosen parameter when using `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`
    `bg` - the `ScoringFunction` for the overall background (i.e. flanking sequence that does not contain a motif)
    `motif` - the `ScoringFunction`s for the motif
    `posPrior` - the `ScoringFunction`s for the position
    `plugInBg` - a switch whether to plug in the (old = last) parameters of the background model, if `false` the background model is initialized again
  Throws:
    `Exception` - if something went wrong (e.g. the `AlphabetContainer` is not simple, ...)

### HiddenMotifsMixture

    public HiddenMotifsMixture(boolean type,
                               int length,
                               int starts,
                               boolean plugIn,
                               HomogeneousScoringFunction bg,
                               NormalizableScoringFunction[] motif,
                               DurationScoringFunction[] posPrior,
                               double sign,
                               boolean plugInBg)
                        throws Exception

  This constructor creates an instance of `HiddenMotifsMixture` that allows to have one site of the specified motifs in a `Sequence`.

  Parameters:
    `type` - the type of hidden motifs, either `CONTAINS_ALWAYS_A_MOTIF` or `CONTAINS_SOMETIMES_A_MOTIF`
    `length` - the length of the modeled sequences (e.g. 500)
    `starts` - the number of recommended starts
    `plugIn` - a switch whether to use plug-in or randomly chosen parameter when using `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`
    `bg` - the `ScoringFunction` for the overall background (i.e. flanking sequence that does not contain a motif)
    `motif` - the `ScoringFunction`s for the sequence motif
    `posPrior` - the `ScoringFunction`s for the position of the the sequence motifs
    `sign` - the significance level to determine the insignificant border positions of a motif
    `plugInBg` - a switch whether to plug in the parameters of the background model in some way, if `false` the background model is initialized uniformly
  Throws:
    `Exception` - if something went wrong (e.g. the `AlphabetContainer` is not simple, ...)

### HiddenMotifsMixture

    public HiddenMotifsMixture(StringBuffer source)
                        throws NonParsableException

  This is the constructor for the interface `Storable`. Recreates a new `HiddenMotifsMixture` out of a `StringBuffer` as returned by `AbstractMixtureScoringFunction.toXML()`.

  Parameters:
    `source` - the XML representation as `StringBuffer`
  Throws:
    `NonParsableException` - if the representation could not be parsed

Method Detail

### clone

    public HiddenMotifsMixture clone()
                              throws CloneNotSupportedException

  Description copied from interface: `ScoringFunction`
  Creates a clone (deep copy) of the current `ScoringFunction` instance.

  Specified by:
    `clone` in interface `ScoringFunction`
  Overrides:
    `clone` in class `AbstractMixtureScoringFunction`
  Returns:
    the cloned instance of the current `ScoringFunction`
  Throws:
    `CloneNotSupportedException` - if something went wrong while cloning the `ScoringFunction`

### getHyperparameterForHiddenParameter

    public double getHyperparameterForHiddenParameter(int index)

  Description copied from class: `AbstractMixtureScoringFunction`
  This method returns the hyperparameter for the hidden parameter with index `index`.

  Specified by:
    `getHyperparameterForHiddenParameter` in class `AbstractMixtureScoringFunction`
  Parameters:
    `index` - the index of the hidden parameter
  Returns:
    the hyperparameter for the hidden parameter

### getNormalizationConstantForComponent

    protected double getNormalizationConstantForComponent(int i)

  Description copied from class: `AbstractMixtureScoringFunction`
  Computes the normalization constant for the component `i`.

  Specified by:
    `getNormalizationConstantForComponent` in class `AbstractMixtureScoringFunction`
  Parameters:
    `i` - the index of the component
  Returns:
    the normalization constant of the component

### getPartialNormalizationConstant

    public double getPartialNormalizationConstant(int parameterIndex)
                                           throws Exception

  Description copied from interface: `NormalizableScoringFunction`
  Returns the partial normalization constant for the parameter with index `parameterIndex`. This is the partial derivation of the normalization constant for the parameter with index `parameterIndex`, in LaTex notation: `\frac{\partial Z(\lambda)}{\partial \lambda_{index}}`.

  Specified by:
    `getPartialNormalizationConstant` in interface `NormalizableScoringFunction`
  Parameters:
    `parameterIndex` - the index of the parameter
  Returns:
    the partial normalization constant
  Throws:
    `Exception` - if something went wrong with the normalization
  See Also:
    `NormalizableScoringFunction.getNormalizationConstant()`

### getEss

    public double getEss()

  Description copied from interface: `NormalizableScoringFunction`
  Returns the equivalent sample size (ess) of this model, i.e. the equivalent sample size for the class or component that is represented by this model.

  Specified by:
    `getEss` in interface `NormalizableScoringFunction`
  Returns:
    the equivalent sample size.

### initializeUsingPlugIn

    protected void initializeUsingPlugIn(int index,
                                         boolean freeParams,
                                         Sample[] data,
                                         double[][] weights)
                                  throws Exception

  Description copied from class: `AbstractMixtureScoringFunction`
  This method initializes the functions using the data in some way.

  Specified by:
    `initializeUsingPlugIn` in class `AbstractMixtureScoringFunction`
  Parameters:
    `index` - the class index
    `freeParams` - if `true`, the (reduced) parameterization is used``
    `data` - the data
    `weights` - the weights for the data
  Throws:
    `Exception` - if the initialization could not be done
  See Also:
    `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`

### initializeFunctionRandomly

    public void initializeFunctionRandomly(boolean freeParams)
                                    throws Exception

  Description copied from interface: `ScoringFunction`
  This method initializes the `ScoringFunction` randomly. It has to create the underlying structure of the `ScoringFunction`.

  Specified by:
    `initializeFunctionRandomly` in interface `ScoringFunction`
  Overrides:
    `initializeFunctionRandomly` in class `AbstractMixtureScoringFunction`
  Parameters:
    `freeParams` - indicates whether the (reduced) parameterization is used
  Throws:
    `Exception` - if something went wrong

### getInstanceName

    public String getInstanceName()

  Description copied from interface: `ScoringFunction`
  Returns a short instance name.

  Specified by:
    `getInstanceName` in interface `ScoringFunction`
  Returns:
    a short instance name

### fillComponentScoreOf

    protected int fillComponentScoreOf(int i,
                                       Sequence seq,
                                       int start)

  This method fills an internal array with the partial scores.

  Parameters:
    `i` - the index of the component
    `seq` - the `Sequence`
    `start` - the start position
  Returns:
    the number of computed partial scores

### fillComponentScores

    protected void fillComponentScores(Sequence seq,
                                       int start)

  Description copied from class: `AbstractMixtureScoringFunction`
  Fills the internal array `AbstractMixtureScoringFunction.componentScore` with the logarithmic scores of the components given a `Sequence`.

  Specified by:
    `fillComponentScores` in class `AbstractMixtureScoringFunction`
  Parameters:
    `seq` - the sequence
    `start` - the start position in `seq`

### getLogScore

    public double getLogScore(Sequence seq,
                              int start)

  Description copied from interface: `ScoringFunction`
  Returns the logarithmic score for the `Sequence` `seq` beginning at position `start` in the `Sequence`.

  Specified by:
    `getLogScore` in interface `ScoringFunction`
  Overrides:
    `getLogScore` in class `AbstractMixtureScoringFunction`
  Parameters:
    `seq` - the `Sequence`
    `start` - the start position in the `Sequence`
  Returns:
    the logarithmic score for the `Sequence`

### getLogScoreAndPartialDerivation

    public double getLogScoreAndPartialDerivation(Sequence seq,
                                                  int start,
                                                  IntList indices,
                                                  DoubleList partialDer)

  Description copied from interface: `ScoringFunction`
  Returns the logarithmic score for a `Sequence` beginning at position `start` in the `Sequence` and fills lists with the indices and the partial derivations.

  Specified by:
    `getLogScoreAndPartialDerivation` in interface `ScoringFunction`
  Parameters:
    `seq` - the `Sequence`
    `start` - the start position in the `Sequence`
    `indices` - an `IntList` of indices, after method invocation the list should contain the indices i where `\frac{\partial \log score(seq)}{\partial \lambda_i}` is not zero
    `partialDer` - a `DoubleList` of partial derivations, after method invocation the list should contain the corresponding `\frac{\partial \log score(seq)}{\partial \lambda_i}`
  Returns:
    the logarithmic score for the `Sequence`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getFurtherInformation

    protected StringBuffer getFurtherInformation()

  Description copied from class: `AbstractMixtureScoringFunction`
  This method is used to append further information of the instance to the XML representation. This method is designed to allow subclasses to add information to the XML representation.

  Overrides:
    `getFurtherInformation` in class `AbstractMixtureScoringFunction`
  Returns:
    the further information as XML code in a `StringBuffer`
  See Also:
    `AbstractMixtureScoringFunction.extractFurtherInformation(StringBuffer)`

### extractFurtherInformation

    protected void extractFurtherInformation(StringBuffer xml)
                                      throws NonParsableException

  Description copied from class: `AbstractMixtureScoringFunction`
  This method is the opposite of `AbstractMixtureScoringFunction.getFurtherInformation()`. It extracts further information of the instance from a XML representation.

  Overrides:
    `extractFurtherInformation` in class `AbstractMixtureScoringFunction`
  Parameters:
    `xml` - the `StringBuffer` containing the information to be extracted as XML code
  Throws:
    `NonParsableException` - if the `StringBuffer` could not be parsed
  See Also:
    `AbstractMixtureScoringFunction.getFurtherInformation()`

### determineNotSignificantPositionsFor

    public int[] determineNotSignificantPositionsFor(int motif,
                                                     Sample[] data,
                                                     double[][] weights,
                                                     int classIdx)

  Description copied from interface: `MutableMotifDiscoverer`
  This method determines the number of not significant positions from each side of the motif with index `motif`.

  Specified by:
    `determineNotSignificantPositionsFor` in interface `MutableMotifDiscoverer`
  Parameters:
    `motif` - the index of the motif in the motif discoverer
    `data` - an array `Sample`s, each array-entry represents on class
    `weights` - the weights of each `Sequence` for each class
    `classIdx` - the index of the current class in `classCounts`
  Returns:
    a two dimensional array containing at position 0 the number of not significant positions from the left and at position 1 the number of not significant positions from the right side
  See Also:
    `Mutable.determineNotSignificantPositions(double, double[], double[], double[][][][], double[][][][], double)`, `MutableMotifDiscoverer.modifyMotif(int, int, int)`, `MutableMotifDiscoverer.modifyMotif(int, double[], double[], double[][][][], double[][][][], int, int)`

### modifyMotif

    public boolean modifyMotif(int motif,
                               double[] weightsLeft,
                               double[] weightsRight,
                               double[][][][] replacementLeft,
                               double[][][][] replacementRight,
                               int offsetLeft,
                               int offsetRight)
                        throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  Manually modifies the motif model with index `motifIndex`. The two offsets `offsetLeft` and `offsetRight` define how many positions the left or right border positions shall be moved. Negative numbers indicate moves to the left while positive numbers correspond to moves to the right.

  Specified by:
    `modifyMotif` in interface `MutableMotifDiscoverer`
  Parameters:
    `motif` - the index of the motif in the motif discoverer
    `weightsLeft` - the weights for the left contrast distributions
    `weightsRight` - the weights for the right contrast distributions
    `replacementLeft` - the replacement distribution for the left side
    `replacementRight` - the replacement distribution for the right side
    `offsetLeft` - the offset on the left side
    `offsetRight` - the offset on the right side
  Returns:
    `true` if the motif model was modified otherwise `false`
  Throws:
    `Exception`

### modifyMotif

    public boolean modifyMotif(int motifIndex,
                               int offsetLeft,
                               int offsetRight)
                        throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  Manually modifies the motif model with index `motifIndex`. The two offsets `offsetLeft` and `offsetRight` define how many positions the left or right border positions shall be moved. Negative numbers indicate moves to the left while positive numbers correspond to moves to the right. The distribution for sequences to the left and right side of the motif shall be computed internally.

  Specified by:
    `modifyMotif` in interface `MutableMotifDiscoverer`
  Parameters:
    `motifIndex` - the index of the motif in the motif discoverer
    `offsetLeft` - the offset on the left side
    `offsetRight` - the offset on the right side
  Returns:
    `true` if the motif model was modified otherwise `false`
  Throws:
    `Exception`
  See Also:
    `MutableMotifDiscoverer.modifyMotif(int, double[], double[], double[][][][], double[][][][], int, int)`

### initializeMotif

    public void initializeMotif(int motif,
                                Sample data,
                                double[] weights)
                         throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  This method allows to initialize the model of a motif manually using a weighted sample.

  Specified by:
    `initializeMotif` in interface `MutableMotifDiscoverer`
  Parameters:
    `motif` - the index of the motif in the motif discoverer
    `data` - the sample of sequences
    `weights` - either `null` or an array of length `data.getNumberofElements()` with non-negative weights.
  Throws:
    `Exception` - if initialize was not possible

### initializeMotifRandomly

    public void initializeMotifRandomly(int motif)
                                 throws Exception

  This method initializes the motif with index `motif` randomly using `ScoringFunction.initializeFunctionRandomly(boolean)`.

  Parameters:
    `motif` - the index of the motif
  Throws:
    `Exception` - either if the index is wrong or if it is thrown by the method `ScoringFunction.initializeFunctionRandomly(boolean)`

### getNumberOfMotifs

    public int getNumberOfMotifs()

  Description copied from interface: `MotifDiscoverer`
  Returns the number of motifs for this `MotifDiscoverer`.

  Specified by:
    `getNumberOfMotifs` in interface `MotifDiscoverer`
  Returns:
    the number of motifs

### getNumberOfMotifsInComponent

    public int getNumberOfMotifsInComponent(int component)

  Description copied from interface: `MotifDiscoverer`
  Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.

  Specified by:
    `getNumberOfMotifsInComponent` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component of the `MotifDiscoverer`
  Returns:
    the number of motifs

### getIndexOfMaximalComponentFor

    public int getIndexOfMaximalComponentFor(Sequence sequence)

  Description copied from interface: `MotifDiscoverer`
  Returns the index of the component with the maximal score for the sequence `sequence`.

  Specified by:
    `getIndexOfMaximalComponentFor` in interface `MotifDiscoverer`
  Parameters:
    `sequence` - the given sequence
  Returns:
    the index of the component with the maximal score for the given sequence

### getGlobalIndexOfMotifInComponent

    public int getGlobalIndexOfMotifInComponent(int component,
                                                int motif)

  Description copied from interface: `MotifDiscoverer`
  Returns the global index of the `motif` used in `component`. The index returned must be at least 0 and less than `MotifDiscoverer.getNumberOfMotifs()`.

  Specified by:
    `getGlobalIndexOfMotifInComponent` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the motif index in the component
  Returns:
    the global index of the `motif`in `component```

### getProfileOfScoresFor

    public double[] getProfileOfScoresFor(int component,
                                          int motif,
                                          Sequence sequence,
                                          int startpos,
                                          MotifDiscoverer.KindOfProfile dist)
                                   throws WrongLengthException

  Description copied from interface: `MotifDiscoverer`
  Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`. This array should be of length
  `sequence.length() - startpos - motifs[motif].length() + 1`.
  A high score should encode for a probable start position.

  Specified by:
    `getProfileOfScoresFor` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
    `dist` - indicates the kind of profile
  Returns:
    the profile of scores
  Throws:
    `WrongLengthException`

### getMotifLength

    public int getMotifLength(int motif)

  Description copied from interface: `MotifDiscoverer`
  This method returns the length of the motif with index `motif` .

  Specified by:
    `getMotifLength` in interface `MotifDiscoverer`
  Parameters:
    `motif` - the index of the motif
  Returns:
    the length of the motif with index `motif`

### setSign

    public void setSign(double newSign)

  This method set the sign that is used in shift, shrink and expand.

  Parameters:
    `newSign` - the new sign in [0,1]

### getSign

    public double getSign()

  This method returns the sign that is used in shift, shrink and expand.

  Returns:
    the sign that is used in shift, shrink and expand.

### adjustHiddenParameters

    public void adjustHiddenParameters(Sample data,
                                       double[] dataWeights)

  This method allows to adjust the hidden parameter in some way.

  Parameters:
    `data` - the data
    `dataWeights` - the weights corresponding to the `Sequence`s in `data`

### getStrandFor

    public StrandedLocatedSequenceAnnotationWithLength.Strand getStrandFor(int component,
                                                                           int motif,
                                                                           Sequence sequence,
                                                                           int startpos)
                                                                    throws Exception

  Description copied from interface: `MotifDiscoverer`
  This method returns the strand for a given subsequence if it is considered as site of the motif model in a specific component.

  Specified by:
    `getStrandFor` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
  Returns:
    the predicted strand annotation
  Throws:
    `Exception` - if the strand could not be computed for any reasons

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD